'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MediaQuerySensor = function () {
    function MediaQuerySensor() {
        _classCallCheck(this, MediaQuerySensor);
    }

    _createClass(MediaQuerySensor, [{
        key: '_checkValidations',
        value: function _checkValidations(breakpoints) {
            if (!this._window.matchMedia) {
                this._window.console.warning(MediaQuerySensor.UNAVAILABLE_MSG);

                return false;
            }

            if (!Array.isArray(breakpoints) || !breakpoints.length) {
                this._window.console.info(MediaQuerySensor.NO_BREAKPOINTS_MSG);

                return false;
            }

            return true;
        }
    }, {
        key: '_mediaChangeHandler',
        value: function _mediaChangeHandler(mediaQuery, action) {
            return function () {
                if (mediaQuery.matches) {
                    action();
                }
            };
        }
    }, {
        key: '_bindMediaQueries',
        value: function _bindMediaQueries(breakpoints) {
            var _this = this;

            breakpoints.forEach(function (_ref) {
                var value = _ref.value,
                    action = _ref.action;

                if (!value || !action || typeof value !== 'string' || typeof action !== 'function') {
                    return false;
                }

                var mediaQuery = _this._window.matchMedia(value);
                var onMediaChange = _this._mediaChangeHandler(mediaQuery, action);

                mediaQuery.addListener(onMediaChange);
                onMediaChange();
            });
        }
    }, {
        key: 'init',
        value: function init(breakpoints) {
            var _window = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : window;

            this._window = _window;

            if (!this._checkValidations(breakpoints)) {
                return false;
            }

            this._bindMediaQueries(breakpoints);
        }
    }], [{
        key: 'UNAVAILABLE_MSG',
        get: function get() {
            return 'MediaQuerySensor is not supported on this browser.';
        }
    }, {
        key: 'NO_BREAKPOINTS_MSG',
        get: function get() {
            return 'No valid breakpoints were passed to MediaQuerySensor.';
        }
    }]);

    return MediaQuerySensor;
}();

exports.default = MediaQuerySensor;